#include <stdio.h>
#include <time.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

#include "config.h"
#include "data.h"
#include "rrd.h"

RRD::RRD(Config * conf)
{
  Conf = conf;
}

void RRD::Save(TrafficDataIterator * it, time_t time)
{
  char *str_ip;
  char filename[MAX_LINELEN];
  char cmd[MAX_LINELEN];
  struct stat buf;
  int err;

  if (!it)
    return;

  do
  {
    str_ip = string_ip(it->getIP());
    sprintf(filename, "%s/rrd/host-%s.rrd", Conf->DataDir, str_ip);
    err = stat(filename, &buf);
    if (err)
    {
      if (errno != ENOENT)
      {
        fprintf(stderr, "File %s: %s\n", filename, strerror(errno));
        continue;
        //exit(errno);
      }

      sprintf(cmd,
              "%s create %s --step 300 DS:in:GAUGE:600:0:U DS:out:GAUGE:600:0:U RRA:AVERAGE:0.5:1:290 RRA:AVERAGE:0.5:2:1010 RRA:AVERAGE:0.5:6:1540 RRA:AVERAGE:0.5:288:370",
              Conf->RrdTool, filename);
      printf("%s\n", cmd);
      if (!Conf->TestRun)
        system(cmd);
    }
    else
    {
      sprintf(cmd, "%s update %s -t in:out %lu:%.10e:%.10e", Conf->RrdTool,
              filename, time, ((double) it->getDownload(0)) / (double) 300.0,
              ((double) it->getUpload(0)) / (double) 300.0);
      printf("%s\n", cmd);
      if (!Conf->TestRun)
        system(cmd);
    }
  }
  while (it->Next());
}

void RRD::Remove(unsigned ip)
{
  char *str_ip;
  char filename[MAX_LINELEN];

  str_ip = string_ip(ip);
  sprintf(filename, "%s/rrd/host-%s.rrd", Conf->DataDir, str_ip);

  printf("Unlinking %s\n", filename);
  if(unlink(filename) != 0)
  {
    fprintf(stderr, "Can't remove %s: %s\n", filename, strerror(errno));
  }  
}
