#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#include "config.h"
#include "data.h"
#include "xmlout.h"

int XMLOut::Save(char* fileName, TrafficDataIterator* it)
{
  char *str_ip;

  if (!it)
    return 1;

  FILE *f = fopen(fileName, "wt");
  if (!f)
    return 0;

  fprintf(f,
          "<?xml version=\"1.0\" encoding=\"utf-8\" standalone=\"yes\" ?>\n");
  fprintf(f, "<data>\n");

  do
  {
    str_ip = string_ip(it->getIP());
    fprintf(f, "\t<ip addr=\"%s\">\n", str_ip);
    fprintf(f, "\t\t<upload>\n");
    for (unsigned int i = 1; i < it->getCounterNumber(); i++)
      fprintf(f, "\t\t\t<%s bytes=\"%llu\" />\n", it->getCounterName(i),
              it->getUpload(i) + it->getUpload(0));
    fprintf(f, "\t\t</upload>\n");
    fprintf(f, "\t\t<download>\n");
    for (unsigned int i = 1; i < it->getCounterNumber(); i++)
      fprintf(f, "\t\t\t<%s bytes=\"%llu\" />\n", it->getCounterName(i),
              it->getDownload(i) + it->getDownload(0));
    fprintf(f, "\t\t</download>\n");
    fprintf(f, "\t</ip>\n");
  }
  while (it->Next());

  fprintf(f, "</data>\n");

  return 1;
}
